Data API
Health
Section titled “Health”GET /data/health (get health status of the server)
Example:
Section titled “Example:”response:
{ "healthy": true, "dependencies": {}, "memstats": { "Alloc": 7, "HeapAlloc": 7, "HeapSys": 19, "HeapIdle": 8, "HeapInUse": 10, "TotalAlloc": 60224, "Sys": 27, "NumGC": 12653 }, "version": ""}GET /data/ready (get ready status of the server)
Example:
Section titled “Example:”response:
ready:trueList Entities
Section titled “List Entities”GET /data/entities/list (list all the entities in the datastore)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| tag | optional | string | filter by tag |
| store | optional | string | store to list (tenant or customer) |
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "datastore": "default", "entities": [ { "name": "answer", "source": "data", "store": "customer" } ]}List hashes
Section titled “List hashes”GET /data/hashes/list (list all the hashes)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| tag | optional | string | filter by tag |
| store | optional | string | store to list (tenant or customer) |
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "datastore": "default", "hashes": { }}Describe Entity
Section titled “Describe Entity”GET /data/entities/list/:entity (describe specified entity)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to describe |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| tag | optional | string | filter by tag |
| store | optional | string | store to list (tenant or customer) |
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "entity": { "description": "", "fields": [ { "name": "id", "description": "", "type": "ULID", "arraytype": "None", "enum": "", "embeddables": null, "computed": true, "serial": false, "inherited": false, "subfields": null, "annotations": [ { "type": "default", "value": "ulid()", "annotations": null, "message": "", "code": "", "plugintype": "cel" } ], "required": true, "stateflow": "", "stateflowfield": "", "tokenized": false, "tokenstrategy": "", "meta": { "defaultvalue": "ulid()", "name": "id", "type": "ulid", "validations": [ { "type": "required" } ] } } ], "name": "survey", "service": "data" }}Entity References
Section titled “Entity References”GET /data/entities/references/:entity (list all the references to the entity)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | optional | string | entity to show references of |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| tag | optional | string | filter by tag |
| store | optional | string | store to list (tenant or customer) |
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "references": { "survey_section_reference": { "name": "survey_section_reference", "description": "", "fromentity": "survey", "fromentityfield": "id", "toentity": "section", "toentityfield": "surveyid", "type": "onetomany", "fromfield": "survey_id", "tofield": "section_surveyid", "iscustom": false, "customentity": "" } }}Get Diff Queries
Section titled “Get Diff Queries”GET /data/entities/diff (get all diff queries to execute in database)
Example:
Section titled “Example:”response:
{ "queries": "create schema if not exists tenant;..."}Sync Diffed Queries
Section titled “Sync Diffed Queries”POST /data/entities/diff/sync (fire all the diffed queries in the database)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "message": "queries ran successfully", "queries": "create schema if not exists tenant;..."}Sync Diffed Entity Queries
Section titled “Sync Diffed Entity Queries”POST /data/entities/diff/sync/:entity (fire diffed queries for entity in the database)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to perform sync the diffed queries for |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "message": "queries ran successfully", "queries": "create schema if not exists tenant;..."}Seed Entity Index
Section titled “Seed Entity Index”POST /data/entities/index/:entity (seed entity index)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”response:
{ "statusid": "1", "status": "success"}Validate additional files datastore
Section titled “Validate additional files datastore”POST /data/entities/validate (validate addition of an entity into the datastore)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to list |
Example:
Section titled “Example:”request:
{ "files": [ "<entity definition in string>" ]}response:
{ "datastore": "default", "errors": null, "path": "surveyappds", "valid": true}Create Entity
Section titled “Create Entity”POST /data/rest/:entity (create an entity)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to create |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| locale | optional | string | locale information |
| stats | optional | boolean | return stats of create operation |
| expression | optional | string | jq expression to evaluate over the response |
| datastore | optional | string | datastore to access |
| customstateflow | optional | string | state: definition |
Example:
Section titled “Example:”request:
{ "<key to add>": "<value to add>", "description": "custom entity field"}response:
{ "data": { "entity": { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field", "id": "<id>", "ownerid": "<owner id>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } }}Get all entity
Section titled “Get all entity”GET /data/rest/:entity (get created entities)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to read |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| page | optional | string | page to select while pagination |
| pagesize | optional | string | define the size of the page while pagination |
| version | optional | string | version to get while cdc is enabled |
| expression | optional | string | jq expression to evaluate over the response |
| event | optional | string | |
| fields | optional | string | |
| stats | optional | boolean | return stats of operation |
| filter | optional | string | filter to apply while reading from the database |
| deleted | optional | boolean | return deleted entities |
| groupby | optional | string | groupby a field |
| id | optional | string | search by id |
| untokenize | optional | boolean | untokenize tokenized fields |
| delta | optional | boolean | add delta information |
| states | optional | boolean | add states |
| meta | optional | string | add meta key in response |
| datastore | optional | string | datastore to access |
Filters Supported
Section titled “Filters Supported”| name | example |
|---|---|
| equal expression | rank = 1 |
| not equal expression | rank != 1 |
| greater than expression | rank > 1 |
| less than expression | rank < 1 |
| greater than or equal expression | rank >= 1 |
| less than or equal expression | rank <= 1 |
| not expression | deletedby not null |
| equal and greater than expression | id = 1 and i > 3 |
| equal, lesser than and greater than expression | id = 1 or i < 3 and i > 3 |
| equal, lesser than and greater than expressions with nested parantheses | id = 1 or ( i < 3 and (i > 3 or i = 3) ) |
| equal and greater than expressions with strings expression | id = 1 and i > “abc” |
| is expression | id is null |
| is not expression | id is not null |
| jsonb expression | embedded_field.field1 = 1 |
| jsonb expression with string expression | embedded_map_field.field1 = ‘foo’ and deletedby is null |
| in operator for empty array expression | id in [] |
| in operator for array of single value | id in [1] |
| in operator for array of value | id in [ 1, 2, 3 ] |
| in operator for array of string value | id in [ ‘abc’ ] |
| array index parsing | id[0] = 32 |
| two quoted strings parsing | id = “01FE35BENNXPSYNFB87QSE27JQ” and node = “manager_approval” |
| crypt quoted string parsing | password = crypt[‘jfkdl’] |
| crypt quoted string parsing | email = ‘email’ and password = crypt[‘jfkdl’] |
| quoted string with null parsing | email = ‘[email protected]’ and password = null and deletedby is null |
| complex string parsing | properties.tenants[].name = “kisai” and properties.roles[].name = “kisai” |
| like parsing | properties like false and id = $id and properties like “kisai” and properties not like ”%#@!$%#$%$#@%#$” and properties ilike “kisai” and properties not ilike “kisai” |
| match parsing | properties match false and id = $id and properties match “kisai” and properties not match ”%#@!$%#$%$#@%#$” and properties imatch “kisai” and properties not imatch “kisai” |
| parsing . with space | properties = ‘abc. fdb’ |
| filter expression parsing example | state in user.roles and state2 = ‘created’ |
Example:
Section titled “Example:”request:
Note: Not Url encoded
https://{{url}}/data/rest/survey/?description = "custom entity field"response:
{ "data": { "survey": [ { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } ] }}Get entity by id
Section titled “Get entity by id”GET /data/rest/:entity/id/:id (get entity by it's id)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to read |
| id | required | string | id of the entity to read |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| delta | optional | boolean | add delta information |
| depth | optional | integer | depth of the children |
| deleted | optional | boolean | return deleted entities |
| unmask | optional | boolean | unmask masked fields |
| untokenize | optional | boolean | untokenize tokenized fields |
| expression | optional | string | jq expression to evaluate over the response |
| locale | optional | string | specifies the locale of the entity |
| version | optional | string | version to get while cdc is enabled |
| range | optional | boolean | |
| payload | optional | boolean | |
| filter | optional | string | filter to apply while reading from the database |
| datastore | optional | string | datastore to access |
Example:
Section titled “Example:”response:
{ "data": { "survey": [ { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } ] }}Get entity paged
Section titled “Get entity paged”GET /data/rest/:entity/page/:pagespec (get entity and limit by pagination)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to read |
| pagespec | required | string | limit of the number of entities and the page to select, comma separated |
Query Parameters
Section titled “Query Parameters”same parameters as in get entities
Example:
Section titled “Example:”response:
when pagespec is 1, 2 here is the page number and 2 is the number of entities in one page
{ "data": { "survey": [ { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" }, { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field entry 2", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } ] }}Update Entity
Section titled “Update Entity”PUT /data/rest/:entity (update an entity)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to update |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| event | optional | string | |
| noversion | optional | string | bypasses creating a version |
| field | optional | string | |
| expression | optional | string | jq expression to evaluate over the response |
| datastore | optional | string | datastore to access |
Example:
Section titled “Example:”request:
{ "id": "<id>", "<key to change>": "<new value>"}response:
{ "data": { "survey": [ { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": null, "deletedon": null, "description": "custom entity field", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } ] }}Delete Entity By ID
Section titled “Delete Entity By ID”DELETE /data/rest/:entity/id/:id (delete an entity by id)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to delete |
| id | required | string | id of the entity to operate |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| deletechildren | optional | boolean | delete children of this entity |
| purge | optional | boolean | hard delete from the database |
| stats | optional | boolean | return stats of operation |
| datastore | optional | string | datastore to access |
Example:
Section titled “Example:”response:
{ "data": { "survey": [ { "createdby": "<email>", "createdon": "<timestamp>", "deletedby": "<email>", "deletedon": "<timestamp>", "description": "custom entity field", "id": "<id>", "ownerid": "<ownerid>", "status": true, "updatedby": "<email>", "updatedon": "<timestamp>" } ] }}Bulk Query
Section titled “Bulk Query”PATCH /data/rest (bulk query to perform multiple data queries at once)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to access |
| search | optional | string | datastore to access |
| expression | optional | string | jq expression to evaluate over the response |
| stats | optional | boolean | return stats of operation |
| meta | optional | string | add meta key in response |
| noversion | optional | string | bypasses creating a version |
Request Format:
Section titled “Request Format:”{ "queries": [ { "query": "entity(DSLquery: argument){fields}" } ]}DSL is an acryonym for Data Selection Language
A DSLquery lets you perform the query on the entity that is being queried for
There are various DSLqueries that can be used
| name | data type | description | example |
|---|---|---|---|
| filter | string | filters the data (discussed above in get all entity) | entity(filter: ‘status is not “null”‘) |
| reference | string | return stats of operation | |
| order | string, csv, space separated | orders the reponse based on the field specified | entity(order: ‘createdon desc’) |
| pagesize | int | pagination parameter for how many entities in the response | entity(page: 2, pagesize: 10) |
| page | int | pagination parameter for which page to select | entity(page: 2, pagesize: 10) |
| delta | boolean | return delta for cdc entity | entity(delta: true) |
| states | boolean | entity(states: true) | |
| cdc | boolean | entity(cdc: true) | |
| id | string | specifies the if of the entity to return | entity(id: ‘01HCVTEX25MQCJCQYJBBAHNK74’) |
| deleted | boolean | query on deleted entities too | entity(deleted: true) |
| unmask | boolean | unmasks masked fields (if access rule is given) | entity(unmask: true) |
| untokenize | boolean | untokenizes masked fields (if access rule is given) | entity(untokenize: true) |
| sendhash | boolean | send hashed fields | entity(sendhash: true) |
| version | string, containing a number of the version | version of the entity to get (cdc entities) | entity(version: “2”) |
Example:
Section titled “Example:”request:
{ "queries": [ { "query": "survey(id: \"01HCKVG283M00JQPS7VCWRDM5Z\", filter: 'status = true', states: true, page: 1, pagesize: 2){section(filter: 'body = \"first section body\"'){question{}}}" } ]}response:
{ "data": { "survey": { "createdby": "<email>", "createdon": "<token>", "deletedby": null, "deletedon": null, "description": "demo", "id": "01HCKVG283M00JQPS7VCWRDM5Z", "status": true, "section": { "body": "first section body", "question": { "questiontype": "text" } } } }}request: Page and Page size
{ "queries": [ { "query": "survey(filter: 'status = true', states: true, page: 1, pagesize: 2){section{question{}}}" } ]}response:
{ "data": { "survey": [ { "description": "second complete survey", "id": "01HCKR9E7CSENFE4ZR7RQRZZKK", "section": [ { "body": "first section body", "heading": "First section", "id": "01HCKR9E7GV7H29BFWQ7278NRV", "question": { "id": "01HCKR9E7S1GCMWR1AX2S5NEJ1", "questiontype": "text", "rules": ".*", "sectionid": "01HCKR9E7GV7H29BFWQ7278NRV" }, "surveyid": "01HCKR9E7CSENFE4ZR7RQRZZKK" }, { "body": "second section does not contain a question", "heading": "Second section", "id": "01HCKR9E7WQ1X3RRMN8CR027YG", "medialink": null, "pagenumber": 0, "question": null, "surveyid": "01HCKR9E7CSENFE4ZR7RQRZZKK" } ], "status": true, "validfrom": "2023-10-13", "validtill": "2023-11-13" }, { "description": "demo", "id": "01HCKVG283M00JQPS7VCWRDM5Z", "ownerid": "01GGCG5ZPVXWA17JFGTS1HD03F", "section": [ { "body": "first section body", "heading": "First section", "id": "01HCKVG287YE55C2CZGNJCJN07", "medialink": null, "pagenumber": 0, "question": { "id": "01HCKVG28E9P1P0H6EXWJ1DE6H", "questiontype": "text", "rules": ".*", "sectionid": "01HCKVG287YE55C2CZGNJCJN07" }, "surveyid": "01HCKVG283M00JQPS7VCWRDM5Z" }, { "body": "second section does not contain a question", "heading": "Second section", "id": "01HCKVG28HEAB5QFJ08RFDTYC7", "medialink": null, "pagenumber": 0, "question": null, "surveyid": "01HCKVG283M00JQPS7VCWRDM5Z" } ], "status": true, "validfrom": "2023-10-13", "validtill": "2023-11-13" } ] }}GraphQL is supported on kis.ai out of the box
Section titled “GraphQL is supported on kis.ai out of the box”Examples
Section titled “Examples”Single Entity Query
Section titled “Single Entity Query”Let’s query items data
request:
{ items(orderby: "id desc", filter: "price > $price1") { id itemname price }}variables:
{ "price1": 300}response:
{ "data": { "items": [ { "id": "01GEQ1YYM0MMXVSFFJFZSD6ADE", "itemname": "Beetroot and Cheese Croquettes", "price": 350 }, { "id": "01GEQ1JEEXSABSTQHHKH6CTV68", "itemname": "Baked Vegetable Casserole", "price": 550 }, { "id": "01GEPREATBE87QFEJT2KHJHPMG", "itemname": "Spanish Gin Tonic", "price": 485 } ] }}Multiple Entities Query
Section titled “Multiple Entities Query”We can query multiple related entities in a single query. Let’s get the list of items for menu entity.
request:
{ menu { name id items { itemname } }}response:
{ "data": { "menu": [ { "id": "01GE1DZNR1QXCBB1T1C43JXJB2", "items": [ { "itemname": "Baked Vegetable Casserole" }, { "itemname": "Beetroot and Cheese Croquettes" } ], "name": "Breakfast all day!" } ] }}Mutations on Entity
Section titled “Mutations on Entity”Let’s create a new menu called Dinner
request:
mutation createMenu ($input: MenuInput) { createMenu (input: $input) { name summary outletid }}variables:
{ "input": { "name": "Dinner", "summary":"Dinner menu", "outletid":"01GE1DBGFC8D8545YM6YXFWK6C" }}response:
{ "data": { "menu": { "id": "01GF32ZPS4HZQ38E07C8PRK103", "name": "Dinner" } }}Get Query GraphQL
Section titled “Get Query GraphQL”POST /data/graphql (graphql query on the data layer)
Example:
Section titled “Example:”request:
{ survey section question answer}response:
{ "data": { "survey": { }, "section": { }, "question": { }, "answer": { } }}Create Query GraphQL
Section titled “Create Query GraphQL”POST /data/graphql (graphql query on the data layer)
Example:
Section titled “Example:”request:
mutation createSurvey ($input: SurveyInput) { createSurvey (input: $input) { description validfrom validto }}inputs:
{ "input": { "description": "graphql", "validfrom": "2023-10-10", "validtill": "2023-10-10" }}response:
{ "data": { "survey": { "description": "Dinner", "validfrom": "2023-10-10", "validtill": "2023-10-10" } }}Multi Action Mutation
Section titled “Multi Action Mutation”Note: add all capabilities for multi action mutation
POST /data/rest (multiple operation can be performed at once)
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| deletechildren | optional | boolean | delete children of this entity |
Request Format
Section titled “Request Format”{ "operations": [ { "action": { "entity": "<<actions to be performed>>", "entity": { "action": "<<actions to be performed>>", "actionKey": "<<actionValue>>" } }, "data": { "<<entity1>>": { } } } ]}Operations
Section titled “Operations”Multiple Operations can be specified, in which each Operation contains an action and data block
Action
Section titled “Action”Action Block format can be of three types
- string
- entity : action string
- entity : action map
Data Block format is the shape of the entity that we’d like to create, update
To delete - just an id is enough
To delete along with it’s children - “deletechildren” key must be set to true in action map (specified in action block)
Example:
Section titled “Example:”request:
{ "operations": [ { "action": { "survey": "create" }, "data": { "survey": [ { "description": "bulk mutation demo", "validfrom": "2023-10-10", "validtill": "2023-11-11" } ] } }, { "action": { "survey": { "action": "delete", "deletechildren": "true" } }, "data": { "survey": [ { "id": "01HD0PNXGNWE6R608MYHTGRMEE" } ] } }, { "action": { "section": "create" }, "data": { "section": { "surveyid": "01HD0PNXGNWE6R608MYHTGRMEE", "body": "some data", "heading": "demo heading" } } } ]}response:
{ "data": { "section": { "body": "some data", "createdon": "2023-10-18T10:16:09+04:00", "deletedby": null, "deletedon": null, "heading": "demo heading", "id": "01HD0PTR6J9ZC0K3BNA9CB2R6F", "medialink": null, "pagenumber": 0, "position": null, "surveyid": "01HD0PNXGNWE6R608MYHTGRMEE", "updatedon": "2023-10-18T10:16:09+04:00" }, "survey": [ { "createdon": "2023-10-18T10:16:09+04:00", "deletedby": null, "deletedon": null, "description": "bulk mutation demo", "id": "01HD0PTR6BE2X8ZCMAW4AY7ZH5", "ownerid": "01GGCG5ZPVXWA17JFGTS1HD03F", "status": true, "updatedon": "2023-10-18T10:16:09+04:00", "validfrom": "2023-10-10", "validtill": "2023-11-11" }, { "createdon": "2023-10-18T10:13:30+04:00", "deletedon": "2023-10-18T10:16:09+04:00", "description": "bulk mutation demo", "id": "01HD0PNXGNWE6R608MYHTGRMEE", "ownerid": "01GGCG5ZPVXWA17JFGTS1HD03F", "status": true, "updatedon": "2023-10-18T10:13:30+04:00", "validfrom": "2023-10-10", "validtill": "2023-11-11" } ] }}Upload Data
Section titled “Upload Data”POST /data/bulk (upload excel sheet to create data)
Uploads the xlsx data into the datastore
It tries to create the data uploaded
It depends on
- sheet name, to decide which entity to insert the data into
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to use |
Example
Section titled “Example”request:

response:
{ "answer": { "errored": 0, "errors": [], "imported": 1 }}Download Data
Section titled “Download Data”PATCH /data/bulk (download data as an excel file)
Depending on the query given, the data is formatted in xlsx file and sent as xml data
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| datastore | optional | string | datastore to use |
Example
Section titled “Example”request:
{ "queries": [ { "query": "survey(pagesize: -1){}" } ]}response:
Response is a application/xml data that is to be saved as a .xlsx file to view the file
xlsx would display this Table

Raml Rest Schema
Section titled “Raml Rest Schema”GET /data/ramlschema (get the rest raml schema)
A config for tenant seshat is needed for this api to work
properties: rest: schema: trueresponse:
#%RAML 1.0title: defaultmediaType: applicaton/jsonprotocols: - HTTPS/rest: patch: description: query entities in bulk queryParameters: stats: displayName: Send Stats type: boolean description: Set the stats about the request handling example: true required: false post: description: create entities in bulk queryParameters: stats: displayName: Send Stats type: boolean description: Set the stats about the request handling example: true required: falseGet All stateflow definitions
Section titled “Get All stateflow definitions”GET /data/stateflows (get all stateflows defined)
response:
stateflows: bugflow2: name: bugflow2 description: "" initial: new states: accepted: "on": FIXED: target: fixed REJECT: target: rejected closed: type: final surveyflow: name: surveyflowGet stateflow definition by name
Section titled “Get stateflow definition by name”GET /data/stateflows/:name (get stateflow definition by name)
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| name | required | string | stateflow to return |
request: if request was to /data/stateflows/bugflow2
response:
stateflows: name: bugflow2 description: "" initial: new states: accepted: "on": FIXED: target: fixed REJECT: target: rejected closed: type: finalDelete Tenant Cache
Section titled “Delete Tenant Cache”DELETE /data/cache (delete tenant cache)
response:
{ "success": true}Full Text Search Single Entity
Section titled “Full Text Search Single Entity”POST /data/rest/:entity/search
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to search |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| expression | optional | string | jq expression to evaluate over the response |
Example:
Section titled “Example:”request:
{ "query": "apple", "filter": ""}response:
{ "data": { "bug": { "estimatedTotalHits": 0, "facetDistribution": null, "hits": [], "hitsPerPage": 0, "limit": 20, "offset": 0, "page": 0, "processingTimeMs": 0, "query": "apple", "totalHits": 0, "totalPages": 0 } }}Full Text Search Multiple Entities
Section titled “Full Text Search Multiple Entities”POST /data/rest
URL Parameters
Section titled “URL Parameters”| name | type | data type | description |
|---|---|---|---|
| entity | required | string | entity to search |
Query Parameters
Section titled “Query Parameters”| name | type | data type | description |
|---|---|---|---|
| search | required | boolean | parameter to enable search payload parsing |
| expression | optional | string | jq expression to evaluate over the response |
Example:
Section titled “Example:”request:
{ "entities": [ "bug", "menu" ], "filter": ""}response:
{ "data": { "bug": { "estimatedTotalHits": 2, "facetDistribution": null, "hits": [ { "boolfield": null, "createdby": "testemail", "createdon": "2023-10-25T09:00:56Z", "deletedby": null, "deletedon": null, "description": null, "id": "01HDK11H1WE5EGFYVRXQQGWBPK", "name": "test bug 1", "state2": "new", "updatedby": "testemail", "updatedon": "2023-10-25T09:00:56Z", "userid": null, "version": 1 }, { "boolfield": null, "createdby": "testemail", "createdon": "2023-10-25T09:02:56Z", "deletedby": null, "deletedon": null, "description": null, "id": "01HDK156D9WN6PVHVDKK5WG1BR", "intfield": null, "name": "test bug 2", "state2": "new", "updatedby": "testemail", "updatedon": "2023-10-25T09:02:56Z", "userid": null, "version": 1 } ], "hitsPerPage": 0, "limit": 20, "offset": 0, "page": 0, "processingTimeMs": 0, "query": "", "totalHits": 0, "totalPages": 0 }, "menu": { "estimatedTotalHits": 0, "facetDistribution": null, "hits": [], "hitsPerPage": 0, "limit": 20, "offset": 0, "page": 0, "processingTimeMs": 0, "query": "", "totalHits": 0, "totalPages": 0 } }}